/* this is the version I gave back to Liming after making a few 
 * minor changes.
 */

/* more changes:
 * 1.  added code to remove articulation points
 */

/*
 * rtg  Random Topogology Generator and graphical previewer.
 *      Based on Waxman's edge distribution function
 *
 *      Written by: Liming Wei
 *		    Computer Science Department,
 *		    University of Southern California
 *		    Los Angeles, CA 90089
 *		    May 1993
 *
 *	Copyright (c) 1993 University of Southern California.
 *	All rights reserved.
 *
 *      Redistribution, modification and use are permitted provided that
 *	the above copyright notice and this paragraph are duplicated in
 *	all forms and that any documentation, advertisements, and other
 *	materials related to such distribution and use acknowledge that the
 *	software was developed by the University Southern California.
 *	The name of the Univerisity may not be used to endorse or
 *	promote products derived from this software without specific
 *	prior written permission.
 *
 *	This software is provided "as is" and without any express or
 *	implied warranties, including, without limitation, for the
 *	fitness for a particular purpose.
 */
static char rcsid[] =
"$Header: /nfs/u5/lwei/multicast/xview/RCS/rtg.c,v 1.13 93/06/02 16:40:02 lwei Exp $";
#include <stdio.h>
#include <math.h>
#include <xview/xview.h>
#include <xview/canvas.h>
#include <xview/cms.h>
#include <xview/xv_xrect.h>

#define N	500 /* Max number of vertices */
#define Xmax 101
#define Ymax 101
#define LL  (sqrt((double)Xmax * Xmax + Ymax * Ymax))  /* 'L' in Waxman's formula */
#define DIST(i, j) \
  (sqrt((double)(point[i].x - point[j].x) * (point[i].x - point[j].x) \
		     +(point[i].y - point[j].y)*(point[i].y - point[j].y)))

int radius[4] = {20, 10, 8, 6}; /* Choose different radius according to different */
			     /* number of nodes in the graph */
int r = 0;	/* index to radius[]. Default use the first entry */

short d[N][N]; /* Graph Adjacency matrix */
short mark[N]; /* Scratch memory, to save node specific temporary information*/
short subg[N][2]; /* Subgraph memory */
short num_subg = 0; /* number of edges in subg[] */
short degree[N];

int dflag = 0; /* display flag */
int eflag = 0; /* display edge flag */
int fflag = 0;
int conflag = 0;
int Conflag = 0;
int oflag = 0;
int pflag = 0; /* print coordinates */
int iflag = 0;
int lflag = 0;
int Pflag = 0;
char Pname[40];
int Sflag = 0;

long seedval= 1;
float  alpha = 0.2,
	beta = 0.2;
double target = 3.0;
double terror = 0.01;
int offset = 0;
void preview();
int num = 10;	/* Number of nodes to generate for current graph */

int shadow = 0;

char filename[81];

struct point {
  short x;
  short y;
 } point[N];

unsigned long *colors;	/* the color table */

float nd();

main(argc, argv)
  int argc;
  char *argv[];
{
  extern char *optarg;
  char *optstring = "s:n:a:b:cdef:hi:opLP:S:Ct:"; 
		/* -s <seed> 16bit value for srand48() */
		/* -n <number> of nodes in the network */
		/* -d  display the graph through the previewer */
		/* -e  display the edge */
		/* -p  print list of point coordinates */
		/* -a  ALPHA */
		/* -b  BETA */
		/* -f <offset>, offset of Waxman fun() starting position */
		/* -c  Produce connected graph */
		/* -i <file> Read subgraph, display highlighted edges  */
		/* -o  output the graph */
                /* -t  target node degree */
                /* -C  look for and fix articulation points */
		/* -L  display labels for each node when previewing the graph */
		/* -P  output the graph in PostScript format, in file pout.ps */
		/* -S  shadow the speficied node */
		/* -h  Usage */
  char c;
  int i,j;

  while ((c = getopt(argc, argv, optstring)) > 0)
	switch(c){
		case 'a':
			sscanf(optarg, "%f", &alpha);
			break;

		case 'b':
			sscanf(optarg, "%f", &beta);
			break;

		case 'c':
			conflag++;
			break;

		case 'h':
			usage();
			break;

		case 's':
			seedval = atol(optarg);
			break;

		case 'i':
			iflag++;
			read_subgraph(optarg);
			break;

		case 'n':
			num = atoi(optarg);
			break;

		case 'd':
			dflag++;
			break;

		case 'e':
			eflag++;
			break;

		case 'f':
			fflag++;
			offset = atoi(optarg);
			break;

		case 'o':
			oflag++;
			break;

		case 'p':
			pflag++;
			break;

		case 't':
			sscanf(optarg, "%lf", &target);
			break;

		case 'C':
			Conflag++;
			break;

		case 'L':
			lflag++;
			break;

		case 'P':
			Pflag++;
			strcpy(Pname, optarg);
			break;

		case 'S':
			Sflag++;
			shadow = atoi(optarg);
			break;
	}

  
  srand48(seedval);	

  build_graph(target);

/*
  roll_coord_dice(num);
  if (pflag){
	for (i = 1; i <=num ; i++){
		printf("N%d X%d Y%d\n", i,  point[i].x, point[i].y);
	}
  }
  srand48(seedval + 3);	
  create_edges(num);
  if (conflag || Conflag){ */
	/*
	 * Attach the partitioned parts (if any) to the nearest
	 * connected component
	 */
/*	connect_graph();
  }

  if (oflag) {
	for (i = 1; i <=num; i++)
	   for (j = i + 1; j <= num; j++){
		if (d[i][j])
			printf("AD%d AD%d %d\n", i, j, d[i][j]);
	   }
  }
*/
  /*
   * Pick the radius for the cirles denoting the nodes
   */
  if (pflag){
	for (i = 1; i <=num ; i++){
		printf("N%d X%d Y%d\n", i,  point[i].x, point[i].y);
	}
  }
  if (oflag) {
	for (i = 1; i <=num; i++)
	   for (j = i + 1; j <= num; j++){
		if (d[i][j])
			printf("AD%d AD%d %d\n", i, j, d[i][j]);
	   }
  }
  r = (num <= 12) ? 0 : ((num <= 20) ? 1 : ((num <= 40) ? 2 : 3));

  if (Pflag) {
	ps_output();
  }

  if (dflag) {
	preview(argc, argv); /* X previewer, never returns */
  }
}

/*
 * Read from in_file the subgraph, into subg[][2]
 */
read_subgraph(in_file)
char *in_file;
{
  FILE *fp;
  char line[300];
  int i,j;

  if ((fp = fopen(in_file, "r")) == NULL){
	fprintf(stderr, "Can't open file %s\n", in_file);
	iflag = 0;
	return;
  }
  while (feof(fp) == 0) {
	if (fscanf(fp, "%d %d", &i, &j) > 0){
		subg[num_subg][0] = i,
		subg[num_subg++][1] = j;
	}
  }
}

/*
 * Toss the vertex onto a rectangle (Xmax by Ymax), with integer grids.
 * The coordinates are recorded in struct coord[N].
 * If a vertex falls on the grid with someone else already there, we
 * throw it away and toss the next vertex, until we have produced 'n'
 * vertices. 
 */
roll_coord_dice(n)
  int n;
{
  int cnt = 0;
  short x, y;
  int i,redo;

  while (cnt < n){
	x = (unsigned short) (lrand48() % (Xmax - 10)) + 5;
	y = (unsigned short) (lrand48() % (Ymax - 10)) + 5;
	redo = 0;
	for (i = 0; i < cnt; i++){
		if (x == point[i].x && y == point[i].y) {
			redo = 1;
			break;
		}
	}
	if (redo == 0){		/* point[0] is not used */
		cnt++;
		point[cnt].x = x;
		point[cnt].y = y;
	}
  }
}

/*
 * Roll the dice again, and use Waxman's formula (exponential distribution)
 * to decide whether there is an edge between each pair of nodes.
 * Record the distance between nodes x and y in d[x][y] if there is
 * and edge between x and y.
 */

create_edges(n)
  int n;
{
  int i,j;
		/*
		 * Waxman's formula doesn't allow really reasonable
		 * graphs. Add an offset to force the reasonableness
		 */
  double df[N + N/2];
  unsigned long a;
  double q, s;

  for (i = 0; i <= LL; i++){
	/*
	 * Waxman's distribution function
	 */
	df[i] = beta * exp((double) (- i) / (double) (LL * alpha));
  }

  /*
   * Now roll the dice and see if it shows the number below Waxman's
   * distribution function at that point. If it does, add an edge.
   */
  for (i = 1; i <= n; i++){
	for (j = i + 1; j <= n; j++) {
		s = sqrt((double)(point[i].x - point[j].x) * (point[i].x - point[j].x)
		     +(point[i].y - point[j].y)*(point[i].y - point[j].y));
		a = lrand48(); /* so that we could check what number shows up */
		q = (double) a / 0x7fffffff;
		if ( q <= df[(int) ((s - offset > 0) ? (s - offset) : 0)]) {
			d[i][j] = d[j][i] = (short) s;
			degree[i]++;
			degree[j]++;
		} else {
			d[i][j] = d[j][i] = 0;
		};
	}
  }
}

/*
 * If the graph in d[][] is partitioned, connect the disconnected node
 * to the nearest connected component (CC).
 */
connect_graph()

{
  int i, j, count = 0, n1, n2;
  double td, mind;


  for (i = 0; i <= num; i++) {
    mark[i] = 0;
  }

  /*
   * Do depth-first search, and mark the connected component that
   * node 1 belongs to
   */
  count = dfs(1, 1);

  while (count < num) {
    mind = infinity();
    for (i = 1; i <= num; i++)
      for (j = 1; j <= num; j++) 
	if (mark[i] && !mark[j]) {
	  td = DIST(i, j);
	  if (td < mind) {
	    mind = td;
	    n1 = i;
	    n2 = j;
	  }
	}
    /* mark the subtree rooted at n2 */
    count += dfs(n2, 1);
    d[n1][n2] = d[n2][n1] = (short) mind;
    degree[n1]++;
    degree[n2]++;
  }

  if (num <= 2) return;

  /* in one version of code I then made the graph 2-connected, I'll
   * not worry about that, since taking repairing articulation points
   * subsumes this.
   */
  if (Conflag)
    repair_articulation_point();

}
	
    
/*
 * co is used to distinguish different connected component
 */
dfs(v, co)
int v;
int co;
{
   int i;
   int count;

   mark[v] = co;
   count = 1;
   for (i = 1; i <= num; i++){
	if (d[v][i] && mark[i] == 0)
		count += dfs(i, co);
   }
   return(count);
}


void
preview(argc, argv)
  int argc;
  char *argv[];
{
  Frame frame;
  void canvas_repaint_proc();

  xv_init(XV_INIT_ARGC_PTR_ARGV, &argc, argv, NULL); 

  frame = (Frame) xv_create(0, FRAME, NULL);

  (void) xv_create(frame, CANVAS,
	CANVAS_REPAINT_PROC, canvas_repaint_proc,
	CANVAS_X_PAINT_WINDOW, TRUE,
	NULL);

  xv_main_loop(frame);
}

void 
canvas_repaint_proc(canvas, paint_window, dpy, xwin, xrects)
Canvas	canvas;		/* unused */
Xv_Window	paint_window;	/*unused*/
Display	*dpy;
Window	xwin;
Xv_xrectlist	*xrects;	/* unused */
{
   GC gc;
  int width, height;
  int i, j, k, dx, dy, rad;
  float xratio, yratio;
  double tang;

  char temp[200];

  gc = DefaultGC(dpy, DefaultScreen(dpy));
  width = (int)xv_get(paint_window, XV_WIDTH);
  height = (int) xv_get(paint_window, XV_HEIGHT);

  xratio = (float) width / Xmax  * 0.95;
  yratio = (float) height/ Ymax * 0.95;

  printf("\nxratio=%f, yratio=%f\n",xratio, yratio);

  colors = (unsigned long *) xv_get(canvas, WIN_X_COLOR_INDICES);
 
  XSetForeground(dpy, gc, colors[7]);
/*  XDrawLine(dpy, xwin, gc, 0, 0, 100, 100);  
	XDrawArc(dpy, xwin, gc,
		 300, 300,
		 100, 100 * 2,
		 0, 64 * 360);
 */

  rad = radius[r];

  for (i = 1; i <= num; i++){
	XDrawArc(dpy, xwin, gc,
		(int) (point[i].x * xratio - rad), 
		(int) (point[i].y * yratio - rad),
		rad * 2, rad * 2,
		0, 64 * 360);
  }

  if (eflag == 0) return;
  for (i = 1; i <= num; i++)
	for (j = i + 1; j <= num; j++){
		if (d[i][j]) {
			/*
			 * Pretty printing. Terminate an edge at the boundary
			 * of a circle, so that terminating and passing-by edges
			 * can be distinguished.
			 */
		   deltaxy(i, j, rad, &dx, &dy);

		   XDrawLine(dpy, xwin, gc,
			(int) (point[i].x * xratio + dx), 
			(int) (point[i].y * yratio + dy),
			(int) (point[j].x * xratio - dx), 
			(int) (point[j].y * yratio - dy));
		}
	}

  if (iflag && num_subg) {
	XSetLineAttributes(dpy, gc, 3, 0, 0, 0);
	for (k = 0; k < num_subg; k++){
		i = subg[k][0];
		j = subg[k][1];
		deltaxy(i, j, rad, &dx, &dy);
		XDrawLine(dpy, xwin, gc,
			(int) (point[i].x * xratio + dx), 
			(int) (point[i].y * yratio + dy),
			(int) (point[j].x * xratio - dx), 
			(int) (point[j].y * yratio - dy));
		
	}
  }

  sprintf(temp, "N=%d ALPHA=%.3f BETA=%.3f Seed=%d NodeDegree=%.2f Target=%.2f\0",
			num, alpha, beta, seedval, nd(), target);
  XDrawString(dpy, xwin, gc,
		10, 10,
		temp, strlen(temp));

  /*
   * If need to put labels on each vertices,
   */
  if (lflag && num <= 20)
	for (i = 1; i <= num; i++){
  		sprintf(temp, "%d",i);
  		XDrawString(dpy, xwin, gc,
		   (int) (point[i].x * xratio - ((strlen(temp) <= 1) ?
				 rad/2 : (rad * 2 / 3))),
		   (int) (point[i].y * yratio + rad/2),
			temp, strlen(temp));

	}

/*  XSetLineAttributes(dpy, gc, 2, 0, 0, 0);
  XDrawLine(dpy, xwin, gc, 0, 0, 100, 300);  
 */
}

/*
 * Compute delta x and delta y for a line from vertex i to vertex j
 */
deltaxy(i, j, rad, deltx, delty)
int i, j;
int rad;
int *deltx, *delty;
{
  double tang;


   if (abs((int) point[i].x - point[j].x) == 0) {
	*deltx = 0;
	*delty = (point[i].y < point[j].y) ? rad : -rad;
   } else {
	tang = (double)
	       (point[i].y - point[j].y)/(point[i].x - point[j].x);
	*deltx = rad / sqrt(1 + tang * tang);
	*delty = tang * rad / sqrt(1 + tang * tang);
	if (point[i].x > point[j].x){
		*deltx = (-1) * (*deltx);
		*delty = (-1) * (*delty);
	}
   }
}

/*
 * compute and return average node degree of the graph.
 */
float nd()
{
  int i,j, sum = 0;

  for (i = 1; i <= num; i++)
	for (j = 1; j <= num; j++){
		if (i != j && d[i][j])
			sum++;
	}
  return ((float) sum/num);
}


/*
 * Output the graph in PostScript format
 */
ps_output()
{
#define PS_WIDTH 2110
#define PS_HEIGHT 1610
#define PS_X_BASE 528	/* Origins of the frame */
#define PS_Y_BASE 420

  int width = PS_WIDTH,
      height = PS_HEIGHT;

  int i, j, k, dx, dy, rad;
  int xorig, yorig;
  float xratio, yratio;

  FILE *outf;

  if ((outf = fopen(Pname, "w")) == NULL){
	fprintf(stderr, "Can't open file %s\n", Pname);
	exit(1);
  }

  fprintf(outf, "%%! PostScript\n\
%%%% Creator: rtg v1.0   --- Liming Wei, USC/ISI, Los Angeles\n\
%%%% End Comments\n/m {moveto} bind def\n/l {lineto} bind def\n\
newpath\n1 setlinewidth\n.25 .25 scale\n90 rotate\n0 -2450 translate\n\
528 420 m\n528 2030 l\n2642 2030 l\n2642 420 l\nclosepath\nstroke\n\
/Helvetica findfont\n30 scalefont\nsetfont\n");

  xratio = (float) PS_WIDTH / Xmax * .95;
  yratio = (float) PS_HEIGHT / Ymax *.95;
  rad = radius[r] * xratio / 5;

  for (i =1; i <= num; i++){
	j = (int) point[i].x * xratio + PS_X_BASE;
	k = (int) PS_HEIGHT - point[i].y * yratio + PS_Y_BASE;
	if (Sflag && shadow == i)
		fprintf(outf, "0 setgray\nstroke\nnewpath\n");

	fprintf(outf, "%d %d %d 0 360 arc\n",
		j, k,
		rad);
	if (Sflag && shadow == i)
		fprintf(outf, ".7 setgray\nfill\nnewpath\n0 setgray\n");
	else
		fprintf(outf, "stroke\n");
	if (lflag)
		fprintf(outf, "%d %d m\n(%d) show\nstroke\n",
			(i < 10) ? j - 10 : j - 18 , k - 10 , i);
  }

  for (i = 1; i <= num; i++)
     for (j = i + 1; j <= num; j++){
	if (d[i][j]){
		deltaxy(i, j, rad, &dx, &dy);
		fprintf(outf, "%d %d m\n%d %d l\n",
			(int) (point[i].x * xratio + dx + PS_X_BASE),
			(int) (PS_HEIGHT - (point[i].y * yratio + dy) + PS_Y_BASE),
			(int) (point[j].x * xratio - dx + PS_X_BASE), 
			(int) (PS_HEIGHT - (point[j].y * yratio - dy) + PS_Y_BASE));
	}
     }

  if (iflag && num_subg) {
	fprintf(outf, "stroke\nnewpath\n8 setlinewidth\n");
	for (k = 0; k < num_subg; k++){
		i = subg[k][0];
		j = subg[k][1];
		deltaxy(i, j, rad, &dx, &dy);
		fprintf(outf, "%d %d m\n%d %d l\n",
			(int) (point[i].x * xratio + dx + PS_X_BASE),
			(int) (PS_HEIGHT - (point[i].y * yratio + dy) + PS_Y_BASE),
			(int) (point[j].x * xratio - dx + PS_X_BASE), 
			(int) (PS_HEIGHT - (point[j].y * yratio - dy) + PS_Y_BASE));
	}
  }
  fprintf(outf,"stroke\nnewpath\n\
/Helvetica findfont\n60 scalefont\nsetfont\n%d %d m\n\
(N=%d ALPHA=%.3f BETA=%.3f Seed=%d NodeDegree=%.2f Target=%.2f) show\n",
PS_X_BASE + 20, PS_Y_BASE + PS_HEIGHT + 60,
num, alpha, beta, seedval, nd(), target);
  fprintf(outf, "stroke\nshowpage\n");
  fclose(outf);

}

usage()
{
printf("Usage:\nrtg \t-a  ALPHA \n\t-b  BETA \n\t-s <seed> 16bit value for srand48()\n\
\t-n <number> of nodes in the network\n\
\t-c  construct connected graph\n\
\t-d  display the graph through the previewer\n\
\t-e  display the edge\n\
\t-i <subgraph> read file 'subgraph' and display it with highlighted edges\n\
\t-o  output the graph in text format\n\
\t-p  print list of point coordinates\n\
\t-L  display labels for each vertex\n\
\t-P  output the graph in PostScript format\n\
\t-h  Usage\n");
}

disp_matrix()
{
  int i, j, k;

  k = (num < 20) ? num : 20;

  for (i = 1; i <= k; i++){
	for(j = 1; j <= k; j++){
		printf("%-3d ",d[i][j]);
	}
	printf("\n");
  }
}


/* find and repair any articulation points.
 */
repair_articulation_point()

{
  int i, j, k, root, count, ok;
  int n1, n2;
  double mind, td;
  short row[N], col[N];


  for (i = 1; i <= num; i++) {
    /* 'remove' current node from the graph */
    for (j = 1; j <= num; j++) {
      row[j] = d[i][j];
      col[j] = d[j][i];
      mark[j] = 0;
      d[j][i] = d[i][j] = 0;
    }
    if (i == 1) 
      root = 2;
    else 
      root = 1;
    ok = 0;  /* indicates whether 'i' is an articulation point */
    while ( !ok ) {
      /* actually for to be more random we could chose a different
       * root each time.
       */
      count = dfs(root, 1);
      if (count == num - 1)
	ok = 1;
      else {  
	/* i is an articulation point.  will 'heal' it by picking 2 
	 * points at random, one in the tree rooted at 'root' and one
	 * not in the tree.  note:  this will improve the situation, but
	 * is not guaranteed to be sufficient, hence we have to repeat
	 * the dfs.
	 */
	/* possible strategies for healing:  pick 2 points farthest away,
	 * closest together, or at random.  I'll do random.
	 */
	printf("%d is an articulation point\n", i);
	mind = infinity();
	for (j = 1; j <= num; j++)
	  for (k = 1; k <= num; k++)
	    if (mark[j] && (!mark[k]) && k != i) {
	      td = DIST(j, k);
	      if (td < mind) {
		mind = td;
		n1 = j;
		n2 = k;
	      }
	    }
/*	r1 = random_uniform_int(1,count);
	r2 = random_uniform_int(1,num-count-1); 
	r3 = 0;
	r4 = 0;
	for (j = 1; j<= num; j++) {
	  if (mark[j]) {
	    r3++;
	    if (r3 == r1)
	      break;
	  }
	}
	r3 = j;
	for (j = 1; j <= num; j++) {
	  if (!mark[j] && j != i) {
	    r4++;
	    if (r4 == r2)
	      break;
	  }
	}
	r4 = j;
*/
	printf("correcting with link %d %d\n", n1, n2);
	d[n1][n2] = d[n2][n1] = 4;

	/* reset mark array so we can do the search again */
	for (j = 1; j <= num; j++)
	  mark[j] = 0;
      }
    }
    /* add current node back into the graph */
    for (j = 1; j <= num; j++) {
      mark[j] = 0;  /* maybe overkill */
      d[i][j] = row[j];
      d[j][i] = col[j];
    }
  }
  

}



/* return a random int uniformly distributed between min and max */

random_uniform_int(min, max)
int min;
int max;

{
  if (min > max)
    panic("random_uniform_int");

  return((lrand48() >> 5) % (max - min + 1) + min);
}


/* Print a message and cause a core dump */

panic(s)
     char *s;
{
  fputs(s, stderr);
  fflush(stderr);
  abort();
}


/* make a graph with a target node degree */

build_graph(target)
double target;

{
  int done = 0;
  double target_hi = target + target * terror;
  double target_lo = target - target * terror;
  double old_beta = beta; /* to restore it if I want */
  double degree_hi;
  double degree_lo;
  double beta_hi, beta_lo;
  double degree_xx;
  double last_diff;

  /* idea is to keep producing graphs until I have one with desired
   * level of connectivity.
   */

/*  printf("target = %f -- %f\n", target_lo, target_hi); */

  /* place the nodes */
  roll_coord_dice(num);

  beta = beta_lo = 0.0;

  create_edges(num);

  degree_lo = nd();

  if (degree_lo >= target_lo)
    panic("build_graph1");

  clear_edges();

  /* need to find an initial beta_hi */
  beta = 2.0;  /* who knows? */

  srand48(seedval + 3);	
  create_edges(num);
  degree_hi = nd();
  while (degree_hi <= target_lo) {
    beta *= 2.0;
    clear_edges();
    srand48(seedval + 3);	
    create_edges(num);
    if (conflag || Conflag) {
      connect_graph();
    }
    degree_hi = nd();
  }
  beta_hi = beta;
  if (beta > 2.0)
    beta_lo = beta/2.0;

/*  printf("initial beta range  = %g -- %g\n", beta_lo, beta_hi); */

  degree_xx = degree_hi;

  while (degree_xx >= target_hi || degree_xx <= target_lo) {
/*    printf("beta = %f -- %f\n", beta_lo, beta_hi); */
    beta = (beta_hi + beta_lo)/2.0;
/*    printf("***trying with beta = %g***\n", beta); */
    clear_edges();
    srand48(seedval + 3);	
    create_edges(num);
    if (conflag || Conflag)
      connect_graph();
    degree_xx = nd();
/*    printf("degree = %f\n", degree_xx); */
    if (degree_xx >= target_hi)
      beta_hi = beta;
    else if (degree_xx < target_lo)
      beta_lo = beta;
    if (last_diff == (beta_hi - beta_lo)) {
      break;
    }
    last_diff = beta_hi - beta_lo;
  }

}

clear_edges()

{
  int i, j;

  for (i = 0; i <= num; i++) {
    degree[i] = 0;
    for (j = 0; j <= num; j++)
      d[i][j] = 0;
  }
}

